]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Make error reporting sane
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index a38e55f695a78b7cd0f36fa2bfc2c470755961d4..59c423732e934b8bc77712a6870e9ad430a4b4b7 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -35,6 +35,15 @@ verbose() {
        if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
+error () {
+       echo "$SELF: error: $1" >&2
+}
+
+fatal () {
+       echo "$SELF: fatal error: $1" >&2
+       exit $2
+}
+
 setup() {
        git config core.worktree     "$GIT_WORK_TREE"
        git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
@@ -45,14 +54,10 @@ setup() {
 
 init() {
        verbose "init() begin"
-       [ -e "$GIT_DIR" ] &&
-               echo "$SELF: fatal: $GIT_DIR exists" &&
-               return 21
+       [ ! -e "$GIT_DIR" ] || fatal "$GIT_DIR exists" 10
        export GIT_WORK_TREE="$HOME"
        mkdir -p "$GIT_WORK_TREE"
-       cd "$GIT_WORK_TREE" ||
-               (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-                return 1) || return $?
+       cd "$GIT_WORK_TREE" || fatal "could not enter $GIT_WORK_TREE" 11
        cd "$GIT_WORK_TREE"
        git init
        setup
@@ -62,8 +67,8 @@ init() {
 use() {
        verbose "use() begin"
        if [ ! -d "$GIT_DIR" ]; then
-               echo E: no repository found for "$VCSH_REPO_NAME" >&2
-               return 1
+               error "no repository found for '$VCSH_REPO_NAME'"
+               return 12
        fi
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
@@ -86,24 +91,24 @@ elif [ "$1" = 'delete' ] ||
      [ "$1" = 'run' ] ||
      [ "$1" = 'seed-gitignore' ] ||
      [ "$1" = 'setup' ]; then
-       [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
+       [ -z $2 ] && fatal "$1: please specify repository to work on" 1
        export VCSH_COMMAND="$1"
        export VCSH_REPO_NAME="$2"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
        shift 2
        export VCSH_EXTERNAL_COMMAND="$*"
        if [ "$VCSH_COMMAND" = 'run' ]; then
-               [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
+               [ -z "$VCSH_EXTERNAL_COMMAND" ] && fatal "$1 $2: please specify a command" 1
        fi
 elif [ "$1" = 'help' ] ||
      [ "$1" = 'list' ]; then
        export VCSH_COMMAND="$1"
 else
-       [ -z $1 ] && help && return 0
+       [ -z $1 ] && help && exit 0
        export VCSH_COMMAND='run'
        export VCSH_REPO_NAME="$1"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-       [ -d $GIT_DIR ] || (help && return 1) || return 0
+       [ -d $GIT_DIR ] || { help; exit 1; }
        shift 1
        export VCSH_EXTERNAL_COMMAND="git $*"
 fi
@@ -113,11 +118,10 @@ for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
 do
        if [ ! -d "$check_directory" ]; then
                if [ -e "$check_directory" ]; then
-                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
-                       return 2
+                       fatal "$check_directory exists but is not a directory" 13
                else
                        echo "$SELF: info: attempting to create $check_directory"
-                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
+                       mkdir -p "$check_directory" || fatal "could not create $check_directory" 50
                fi
        fi
 done
@@ -132,13 +136,12 @@ if [ "$VCSH_COMMAND" = 'clone' ]; then
        git fetch
        for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
                [ -e "$object" ] &&
-                       echo "$SELF: error: $object exists." &&
+                       error "$object exists." &&
                        VCSH_CONFLICT=1;
        done
        [ "$VCSH_CONFLICT" = '1' ] &&
-               echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
-               echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-               return 3
+               fatal "will stop after fetching and not try to merge!
+  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" 17
        git merge origin/master
        verbose "clone end"
 
@@ -150,7 +153,7 @@ elif [ "$VCSH_COMMAND" = 'delete' ]; then
        verbose "delete begin"
        old_dir="$PWD"
        cd "$HOME"
-       use || return $?
+       use || exit $?
        echo "$SELF: info: This operation WILL DETROY DATA!"
        files=$(git ls-files)
        echo "These files will be deleted:
@@ -160,7 +163,7 @@ $files
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
        read answer
-       [ "x$answer" = "xYes, do as I say" ] || return 1
+       [ "x$answer" = "xYes, do as I say" ] || exit 16
        for file in $files; do
                rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
        done
@@ -170,7 +173,7 @@ To continue, type \"Yes, do as I say\""
 
 elif [ "$VCSH_COMMAND" = 'enter' ]; then
        verbose "enter begin"
-       use || return $?
+       use || exit $?
        $SHELL
        verbose "enter end"
 
@@ -188,13 +191,13 @@ elif [ "$VCSH_COMMAND" = 'list' ]; then
 
 elif [ "$VCSH_COMMAND" = 'run' ]; then
        verbose "run begin"
-       use || return $?
+       use || exit $?
        $VCSH_EXTERNAL_COMMAND
        verbose "run end"
 
 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        verbose "seed-gitignore begin"
-       use || return $?
+       use || exit $?
        # Switching directory as this has to be executed from $HOME to be of any use.
        # Going back into old directory at the end in case `vcsh use` is reactivated.
        old_dir="$PWD"
@@ -206,8 +209,7 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
                        file="$new"
                done;
        done | sort -u)
-       tempfile=$(mktemp) ||
-               (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
+       tempfile=$(mktemp) || fatal "could not create tempfile" 51
        echo '*' > "$tempfile"
        for gitignore in $gitignores; do
                echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
@@ -215,28 +217,26 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        done
        diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
                rm -f "$tempfile" &&
-               return
+               exit
        if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
                echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
                mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-                       (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
-                        return 1) || return $?
+                       fatal "could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" 53
        fi
        mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-               (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
+               fatal "could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" 53
        cd "$old_dir"
        verbose "seed-gitignore end"
 
 elif [ "$VCSH_COMMAND" = 'setup' ]; then
        verbose "seed-gitignore begin"
-       use   || return $?
-       setup || return $?
+       use   || exit $?
+       setup || exit $?
        verbose "seed-gitignore end"
 
 else
        verbose "defaulting to calling help()"
        help
-       echo "$SELF: fatal: You should never reach this code. File a bug, please."
-       return 99
+       fatal "You should never reach this code. File a bug, please." 99
 
 fi